/*
Demo for 8082

Software:
    Compiler: BC++ 3.1
    Compile mode: large
    Project: Freq.c
             8082L.Lib
             8000E.Lib

Hardware: I-8000 MCU + 8082
*/

/*          
[2005,Dec,9] by Kevin
    Use 8082 lib version 1.0.0
*/
#include <stdlib.h>
#include "..\..\..\..\lib\8000E.h"
#include "..\..\..\..\lib\8082.h"

void main(void)
{
    int i,iSlot,iChannel,iRet;
    unsigned long T1;
    int iUpdated;
    float fValue;
    
    char sTemp[20];

    InitLib();
    
    i8082_GetLibDate(sTemp);
    Print("**************************************\n\r");
    Print("   8082 demo\n\r");
    Print("    compiled [%s]",__DATE__);
    Print("\n\r"); 
    Print("   Lib version %x\n\r",i8082_GetLibVersion());
	Print("   Lib dated %s\n\r",sTemp);
    Print("**************************************\n\r");
    Print("Press 'q' to quit.\n\r\n\r");
    
    Print("Slot number (0~7)=");
	LineInput(sTemp,20);
	iSlot=atoi(sTemp);
    iRet=i8082_Init(iSlot); 
    
    Print("   Firmware version %d\n\r\n\r",i8082_GetFirmwareVersion(iSlot));
	  
                                 
    if(iRet==NoError)
	{
		Print("Initiate 8082 on slot%d ok.\n\r",iSlot);
        T1=GetTimeTicks();
        
        for (;;)
        {
            if ((GetTimeTicks()-T1) >=25) // Print Counter value every 50 ms
            {
                T1=GetTimeTicks();
                for(iChannel=0;iChannel<8;iChannel++)
                {
                    iUpdated=i8082_ReadFreq(iSlot,iChannel,&fValue);
                    
                    if(iUpdated>0)
                        Print("Ch%d=%7.3f  ",iChannel,fValue);
                    else
						Print("Ch%d=%7.3f* ",iChannel,fValue); //The frequency was not updated.
                }
                Print("\n\r");
            }
            
            if (Kbhit())
            {
                iRet=Getch();
                if(iRet=='q') //Press 'q' to quit the program.
                    return;
            }
        }
    }
    else 
		Print("Can't find 8082");
}                                     